<template>
    <div class="d-flex flex-column">

        <div class="d-flex justify-content-end align-items-center">
            <button type="button" class="btn btn-primary" @click="goToEntry">
                <fa icon="plus"/>  New Blog
            </button>
        </div>

        <div class="d-flex flex-column border border-light rounded-lg shadow-lg p-5 my-5 bg-white  ">
            <h1 class="font-weight-bold"> Blog Posts</h1>

            <div class="d-flex justify-content-center align-items-center mt-5" v-if="blogs.length === 0">
                <p class="font-weight-bold font-italic"> -No blog post yet!-</p>
            </div>

            <div class="row mt-3">
                <div class="col-12 col-md-6 col-lg-4" v-for="blog in blogs" :key="blog.id">
                    <blog-card :blog="blog" @removedBlog="handleRemoved"/>
                </div>
            </div>

            <div class="d-flex justify-content-center align-items-end mt-3 ">
                <pagination v-if="blogs.length > 0" :pagination-links="paginationLinks" @getLink="getLink"/>
            </div>
        </div>
    </div>
</template>

<script>
    import BlogCard from "../components/BlogCard";
    import VButton from "../components/Button";
    import Card from "../components/Card";
    import Pagination from "../components/Pagination";

    export default {
        components: {Pagination, Card, VButton, BlogCard},
        middleware: 'auth',

        metaInfo() {
            return {title: 'Home'}
        },
        data(){
            return {
                blogs:[],
                paginationLinks:[]
            }
        },
        mounted(){
            this.getBlogs();
        },
        methods:{
            goToEntry(){
                this.$router.push({name:'blog-entry'})
            },
            async getBlogs(url = null){

                await axios.get(url === null ? '/api/blogs' : url).then(response =>{
                    if(response.data.success){
                        this.blogs = response.data.result.data;
                        this.paginationLinks = response.data.result.links
                    }
                    else
                        this.$toast.error(response.data.message);
                }).catch(e =>{
                    console.log(e);
                })
            },
            async handleRemoved(e){
                if(e)
                    await this.getBlogs();

            },
            async getLink(url){
                await this.getBlogs(url);
            }
        }
    }
</script>
